#!/usr/bin/python

# better_ab_testing.py
#       --copyright--                   Copyright 2012 (C) Tranzoa, Co. All rights reserved.    Warranty: You're free and on your own here. This code is not necessarily up-to-date or of public quality.
#       --url--                         http://www.tranzoa.net/tzpython/
#       --email--                       pycode is the name to send to. tranzoa.com is the place to send to.
#       --bodstamps--
#       December 9, 2012        bar
#       March 5, 2023           bar     future print
#       --eodstamps--
##      \file
#       \namespace              tzpython.better_ab_testing
#
#
#       From:   http://stevehanov.ca/blog/index.php?id=132
#               Except the pseudo-code there seems to have the division inverted.
#
#
#       The idea is to find better options from a bunch of options.
#       In the code comments below "option" is called "lever" - from a multi-armed slot machine player.
#
#       One thing the test code in main showed up is that if the rewards are always better than 1, the first guy choosen gets chosen a lot.
#       The rewards always want to be under INITIAL_PAY.
#
#


from    __future__  import  print_function

import  random


RANDOM_CHOICE   = 0.1

MAX_PAY         = 0.99999
INITIAL_PAY     = 1.00000


class   an_option(object) :
    def __init__(me, name) :
        me.name = name
        me.cnt  = 1
        me.pay  = INITIAL_PAY

    def choose(me) :
        me.cnt += 1
        return(me.cnt)

    def reward(me, reward = None) :
        if  reward is None :
            reward  = MAX_PAY
        me.pay     += min(MAX_PAY, reward)
        return(me.pay)

    #   an_option



def choose(choices) :
    if  not len(choices) :
        return(None)

    if  random.random() < RANDOM_CHOICE :
        ci      = random.randint(0, len(choices) - 1)
    else        :
        ci      = 0
        c       = choices[ci]
        cv      = c.pay / c.cnt
        for i, c in enumerate(choices) :
            v   = c.pay / c.cnt
            if  cv  < v :
                cv  = v
                ci  = i
            pass
        pass

    choices[ci].choose()

    return(ci)


if  __name__ == '__main__' :

    ca  = [ an_option(i) for i in range(100) ]
    for i in range(len(ca) * 31) :
        ci  = choose(ca)
        c   = ca[ci]
        # c.reward((len(str(c.name)) + random.random() * 20) / 20.0)
        c.reward(len(str(c.name)) - 1)

    for c in ca :
        print("%4s %6.1f %4u --- %6.1f" % ( str(c.name), c.pay, c.cnt, c.pay / c.cnt ))

    pass


#
#
# eof
