#!/usr/bin/python

# clear_high_bit.py
#       --copyright--                   Copyright 2011 (C) Tranzoa, Co. All rights reserved.    Warranty: You're free and on your own here. This code is not necessarily up-to-date or of public quality.
#       --url--                         http://www.tranzoa.net/tzpython/
#       --email--                       pycode is the name to send to. tranzoa.com is the place to send to.
#       --bodstamps--
#       November 27, 2011       bar
#       May 27, 2012            bar     doxygen namespace
#       March 5, 2023           bar     future print
#       --eodstamps--
##      \file
#       \namespace              tzpython.clear_high_bit
#
#
#       Clear the high bits in the given file.
#
#

from    __future__  import  print_function

import  os
import  sys

import  replace_file
import  TZCommandLineAtFile
import  tzlib


helpstr = """
%s (options) file_name...

    Clear the high bits of all bytes in the given file(s).

Options:

    --output    file_name   Set the output file name for the next file converted.
                            None given: Do the conversion in-place.
    --subdirs               Find ambiguous-named files in sub-directories.

"""


#
#
if __name__ == '__main__' :

    program_name    = sys.argv.pop(0)
    TZCommandLineAtFile.expand_at_sign_command_line_files(sys.argv)


    subdirs = False

    while True :
        oi  = tzlib.array_find(sys.argv, [ "--help", "-h", "-H", "/h", "/H", "-?", "/?" ] )
        if  oi < 0 :    break
        print(helpstr % os.path.basename(program_name))
        sys.exit(254)

    while True :
        oi  = tzlib.array_find(sys.argv, [ "--subdirs", "--sub_dirs", "--sub-dirs", "--subdir", "--sub_dir", "--sub-dir", "--sd", "-s" ] )
        if  oi < 0 :    break
        del sys.argv[oi]
        subdirs   = True


    doem        = []
    ofile_name  = None
    while len(sys.argv) :
        op  = sys.argv.pop(0)

        if  op.lower() in [ "--output", "--out_put", "--out-put", "--outfile", "--out_file", "--out-file", "-o" ] :
            ofile_name  = sys.argv.pop(0)
        else :
            fns = tzlib.ambiguous_file_list(op, do_sub_dirs = subdirs)
            if  not len(fns) :
                print("No such file %s!" % op)
                sys.exit(101)

            if  (len(fns) > 1) and ofile_name :
                print("Output name %s for multiple files %s!" % ( ofile_name, str(fns) ))
                sys.exit(102)

            for fn in fns :
                doem.append([ fn, ofile_name ])
                ofile_name  = None
            pass
        pass

    for fn, ofn in doem :
        fi  = open(fn, "rb")
        fd  = fi.read()
        fi.close()

        c   = False
        fd  = list(fd)
        for bi, b in enumerate(fd) :
            if  ord(b) > 127 :
                c       = True
                fd[bi]  = chr(ord(b) & 0x7f)
            pass

        if  ofn or c :
            ofn = ofn or fn
            tfn = ofn + ".tmp"
            fo  = open(tfn, "wb")
            fo.write("".join(fd))
            fo.close()
            replace_file.replace_file(ofn, tfn, ofn + ".bak")
        pass

    pass

#
#
#
# eof
