#!/usr/bin/python

# gmap_image.py
#       --copyright--                   Copyright 2019 (C) Tranzoa, Co. All rights reserved.    Warranty: You're free and on your own here. This code is not necessarily up-to-date or of public quality.
#       --url--                         http://www.tranzoa.net/tzpython/
#       --email--                       pycode is the name to send to. tranzoa.com is the place to send to.
#       --bodstamps--
#       October 7, 2019         bar
#       March 5, 2023           bar     future print
#       --eodstamps--
##      \file
#       \namespace              tzpython.gmap_image
#
#
"""
gmap_image.py   (options)   image_file(s)

  Options:

  Run the browser to show where the given image is with Google Maps.

"""

from    __future__  import  print_function

import  glob
import  os
import  re
import  subprocess
import  sys
import  webbrowser

import  tzlib
import  tz_google_earth
import  tz_jpg


def oops(err_msg) :
    sys.stderr.write(err_msg + "\n")
    sys.exit(1)


if  __name__ == '__main__' :
    import  TZCommandLineAtFile

    program_name        = os.path.basename(sys.argv[0] or __file__ or __doc__.split()[0])

    TZCommandLineAtFile.expand_at_sign_command_line_files(sys.argv)

    if  len(sys.argv)  <= 1 :
        sys.argv.append("-h")

    if  tzlib.array_find([ a.lower() for a in sys.argv ], [ "--help", "/help", "-h", "-?", "/?", "-?", "/h", ] ) >= 0 :
        ds  = re.sub(r'^(\s*)(\S+)', r'\1' + program_name, __doc__)
        print(ds)
        sys.exit(0)                         # well, there goes my 254 :)

    todo    = []
    for a  in sys.argv[1:] :
        fns = glob.glob(tzlib.expand_user_vars(a))
        for fn in fns   :
            jpeg        = tz_jpg.a_jpg(fn)
            exif        = jpeg.get_exif()
            if  not exif :
                print(fn, "has no EXIF data!")
            else        :
                lat     = exif.get_latitude()
                if  lat is None :
                    print(fn, "has no latitude!")
                else        :
                    lon     = exif.get_longitude()
                    if  lon is None :
                        print(fn, "has no longitude!")
                    else    :
                        url = tz_google_earth.google_maps_lat_lon_url(lat, lon)
                        todo.append([ fn, url, lat, lon ])
                    pass
                pass
            pass
        pass

    for fn, url, lat, lon in todo :
        print(os.path.basename(fn), lat, lon)
        try :
            webbrowser.open_new_tab(url)
        except ( webbrowser.Error, AttributeError ) :
            try :
                webbrowser.open(url)
            except ( webbrowser.Error, AttributeError ) :
                try :
                    fffn        = "C:/Program Files/Mozilla Firefox/firefox.exe"
                    if  not os.path.isfile(fffn) :
                        fffn    = "C:/Program Files (x86)/Mozilla Firefox/firefox.exe"
                    if  not os.path.isfile(fffn) :
                        fffn    = "firefox"
                    # print("@@@@", url)
                    subprocess.Popen( [ fffn, url ] )
                except WindowsError :
                    raise
                pass
            pass
        pass
    pass


# eof
