#!/usr/bin/python

# pyflakes_ignore.py
#       --copyright--                   Copyright 2023 (C) Tranzoa, Co. All rights reserved.    Warranty: You're free and on your own here. This code is not necessarily up-to-date or of public quality.
#       --url--                         http://www.tranzoa.net/tzpython/
#       --email--                       pycode is the name to send to. tranzoa.com is the place to send to.
#       --bodstamps--
#       March 7, 2023           bar
#       --eodstamps--
##      \file
#       \namespace              tzpython.pyflakes_ignore
#
#
#   From https://chase-seibert.github.io/blog/2013/01/11/bypass_pyflakes.html
#

import  sys

from pyflakes.scripts import pyflakes
from pyflakes.checker import Checker


ignore  = "pyflakes_ignore"
flines  = {}            # keyed by source file name, valued by lines array


def report_with_ignore(me, messageClass, *args, **kwargs):
    lineno  = args[0].lineno - 1
    if  me.filename not in flines :
        fi  = open(me.filename, "r")
        flines[me.filename] = fi.readlines()
        fi.close()
    if  ignore not in flines[me.filename][lineno] :
        me.messages.append(messageClass(me.filename, *args, **kwargs))
    pass

#   monkey patch checker to support lines marked for being ignored
Checker.report = report_with_ignore

#
#
if __name__ == '__main__' :
    if  len(sys.argv) > 1 :
        pyflakes.main()
    pass

#
# eof
