#!/usr/bin/python

# python_2to3_grep_fors.py
#       --copyright--                   Copyright 2023 (C) Tranzoa, Co. All rights reserved.    Warranty: You're free and on your own here. This code is not necessarily up-to-date or of public quality.
#       --url--                         http://www.tranzoa.net/tzpython/
#       --email--                       pycode is the name to send to. tranzoa.com is the place to send to.
#       --bodstamps--
#       March 3, 2023           bar
#       March 7, 2023           bar     FileType
#       March 8, 2023           bar     keys, values, items
#       April 14, 2023          bar     don't find new print() functions
#       April 22, 2023          bar     keep fixing non print() print sensing
#       January 20, 2024        bar     maxint
#       April 13, 2024          bar     comments about what to do about our output
#                                       has_key
#       --eodstamps--
##      \file
#       \namespace              tzpython.python_2to3_grep_fors
#

from    __future__  import  print_function

import  glob
import  re
import  sys

import  tzlib


FILE_NAMES  = [
                'tz_random.py',
                'tz_sudoku.py',
              ]
if  False   :
    STRINGS = [
              ]
    WORDS   = [
              ]
else        :
    WORDS   = [
                'print(?!\s*\()',           # add __future__ and put parens and ''' ">> fn" -> , file = fn ''' and ''' end of statement "," -> end = ' ' '''
                'xrange',                   # xrange = range for only p3 at top of program
                'map',                      # list(map(...))
                'cmp',                      # p3 at top of program
                'chr',                      # ??? maybe problems for non-ASCII (latin1 and unicode)
                'long',                     # p3 at top of program
                'ord',                      # ??? maybe problems for non-ASCII (latin1 and unicode)
                'maxint',                   # convert to maxsize
                'basestring',               # p3 at top of program
                'str',                      # ??? maybe problems for non-ASCII (latin1 and unicode)
                'string.join',              # ??? maybe problems for non-ASCII (latin1 and unicode)
                'string.split',             # ??? maybe problems for non-ASCII (latin1 and unicode)
                'sort',                     # can use functools.cmp_to_key(cmp)
                '\bkeys\b',                 # new sort - we have helper rtns in tzlib.py
                '\bvalues\b',               # list(.values())
                '\bitems\b',                # list(.items())
                '\bhas_key\b',              # change x.has_key(y) to (y in x)
                'unichr',                   # ??? maybe problems for non-ASCII (latin1 and unicode)
                'unicode',                  # ??? maybe problems for non-ASCII (latin1 and unicode)
                'cgi',                      # ???
                'urllib',                   # convert like in tzlib.py and others
                'urllib2',                  # convert like in tzlib.py and others
                'urlparse',                 # convert like in tzlib.py and others
                'exec',                     # ???
                'SocketServer',             # ???
                'StringIO',                 # convert like others
                'BytesIO',                  # convert like others
                'random.choice',            # can't be .keys() and the like. p3 iterators
                'random.choose',            # can't be .keys() and the like. p3 iterators
                'FileType',                 # ???
              ]

    STRINGS = [
                'Type',
                'ueue',
                "b'",
                'b"',
                '0L',
                'fL',
                r'[^/]/[^/]',
              ]

WORDS   = [ r"\b" + s + r"\b"   for s in WORDS ]
REGXS   = [ re.compile(tzlib.convert_to_utf8(w))    for w in WORDS + STRINGS ]


class   a_find(object) :
    """ A search hit. """

    def __init__(me, file_name, line_no, regx, ln) :
        me.fn   = file_name
        me.i    = line_no
        me.rx   = regx
        me.ln   = ln

    #   a_find


class   a_file(object) :
    """ The file name and lines of text in the file, blank or not. """

    def __init__(me, file_name) :
        me.fn   = file_name
        fd      = tzlib.read_whole_binary_file(fn)
        lns     = re.split(br"[\t\f\r ]*\n", fd)
        if  len(lns) :
            lns[-1] = lns[-1].lstrip()
        if  not len(lns[-1]) :
            lns.pop()
        lns     = [ re.sub(br"#.*$", b"", ln).rstrip() for ln in lns ]
        me.lns  = lns

    def search(me, regx) :
        """ Find print lines from this file matching the given regex. Return an array with a_find()s. """
        ga  = []
        for i, ln in enumerate(me.lns) :
            g   = regx.search(ln)
            if  g :
                ga.append(a_find(me.fn, i, regx, ln))
            pass
        return(ga)

    #   a_file


def make_files(amb_name) :
    """ Return an array of file names from the given name or glob-name. """
    return([ a_file(fn) for fn in glob.glob(amb_name) ])



if  __name__ == '__main__' :
    import  TZCommandLineAtFile

    argv        = sys.argv[1:]
    TZCommandLineAtFile.expand_at_sign_command_line_files(argv)

    ffns        = argv or FILE_NAMES

    fns         = []
    for fn in ffns :
        fns    += make_files(fn)

    fns.sort(key = lambda f : f.fn.upper())

    found       = []
    for f in fns :
        for regx in REGXS :
            found  += f.search(regx)
        pass

    fnlen       = max([ len(f.fn)           for f in found ] + [ 10 ]) + 4
    rxlen       = max([ len(f.rx.pattern)   for f in found ] + [ 10 ]) + 4      # +4 to allow room for \b on both ends

    for f in found :
        ln      = f.ln
        ln      = tzlib.convert_to_unicode(ln)
        pln     = "%-*s %-*s %-5u: %s" % ( fnlen, f.fn, rxlen, tzlib.convert_to_unicode(f.rx.pattern), f.i, ln, )
        if  sys.version_info[0] < 3 :
            print(tzlib.convert_to_utf8(pln))
        else    :
            print(pln)
        pass

    pass


#
# eof
