#!/usr/bin/python

# tz_wx_widgets.py
#       --copyright--                   Copyright 2007 (C) Tranzoa, Co. All rights reserved.    Warranty: You're free and on your own here. This code is not necessarily up-to-date or of public quality.
#       --url--                         http://www.tranzoa.net/tzpython/
#       --email--                       pycode is the name to send to. tranzoa.com is the place to send to.
#       --bodstamps--
#       December 1, 2007        bar
#       December 16, 2007       bar     whitespace
#       December 23, 2007       bar     kludge in icon logic (which should have been done differently, anyway.)
#       March 18, 2008          bar     exit param for bail_out()
#       May 15, 2008            bar     only fuss if time is off by more than 2 seconds
#       May 17, 2008            bar     email adr
#       May 20, 2009            bar     smarter command line help
#       September 16, 2010      bar     move write_window_image() here from elsewhere
#       November 18, 2010       bar     classes are objects now
#       April 14, 2011          bar     put the phone homer download to the app's desired directory if he has one spec'd
#       July 27, 2011           bar     diddle with the cmd line help OK button's bottom a bit under Linux so the OK button is fully shown
#       November 29, 2011       bar     pyflake cleanup
#       May 27, 2012            bar     doxygen namespace
#       September 13, 2012      bar     wx.OK is wx.ID_OK
#       February 4, 2013        bar     comment about screen grabs
#       February 8, 2013        bar     find_optimum_text_area_font_size()
#       February 12, 2013       bar     change the screen grabber to match my clearelooks, gnome2 machine
#       February 19, 2013       bar     epydoc indentation corrected
#       June 2, 2013            bar     a_text_entry_popup()
#       June 9, 2013            bar     sigh. No, wx.OK is not wx.ID_OK and MessageDialog requires wx.OK under Windows, or under the version I have running under Windows, or something
#       June 26, 2013           bar     a_progress_status_bar()
#       August 9, 2013          bar     put the already running popup on top
#       August 21, 2013         bar     option to use global dir for checking instance running
#                                       only make the already-running object once
#       September 21, 2013      bar     better write_window_image under linux
#                                       and let it return the saved file name and allow a file name to be passed to it
#       September 23, 2013      bar     correct namespace
#       October 6, 2013         bar     window_size()
#                                       is_event_within_windows
#       October 11, 2013        bar     low and high size params to find_optimum_text_area_font_size
#       January 2, 2014         bar     get_matching_wx_key()
#       February 9, 2014        bar     is mouse in rtns
#       February 20, 2014       bar     set_label()
#       March 16, 2014          bar     allow soft keyboard in text entry dialog box
#       June 25, 2014           bar     stable_window_dimensions()
#       July 27, 2014           bar     don't pop up the stale lock fuss budget
#       August 25, 2014         bar     promote a_help_dialog()
#       January 12, 2015        bar     window_showing
#       November 7, 2015        bar     show_msg takes an optional parent window
#       May 10, 2016            bar     change a debug/code-helper printout and add a comment
#       May 15, 2016            bar     an_off_screen_html_window
#                                       window_*to_bitmap()
#       May 16, 2016            bar     uh, import wx.html
#                                       futz with the html background color
#       June 24, 2016           bar     an_app() - a wx app html windows to access .png files from memory with <img src='memory:name_of_png_file'>
#       June 28, 2016           bar     is_event_within_windows handles Sizers
#       January 8, 2017         bar     paint_dot_on_full_screen()
#       November 7, 2017        bar     maxint->maxsize
#       March 4, 2023           bar     python3
#       --eodstamps--
##      \file
#       \namespace              tzpython.tz_wx_widgets
#
#
#       Bunch of routines that are duped here and there.
#
#


from    __future__  import  print_function

import  sys

if  sys.version_info[0] < 3 :
    from    cStringIO   import  StringIO
else :
    from    io          import  StringIO

import  zlib
import  os
import  re
import  tempfile
import  time

try :
    cmp
except NameError :
    cmp     = lambda x, y : (x > y) - (x < y)

import  wx
import  wx.html

import  phone_homer
import  tz_net_time
import  tz_parse_time
import  tzlib


## Used in window titles, etc.
OUR_TITLE   = "tz_wx_widgets"

## Used in window titles, etc.
OUR_NAME    = ""


def our_title(title = None) :
    """ Set the program's window title and name. """

    global  OUR_TITLE
    global  OUR_NAME

    ov  = OUR_TITLE

    if  title != None :
        OUR_TITLE   = title
        OUR_NAME    = OUR_TITLE.replace(" ", "").replace("-", "")

    return(ov)


def our_name(name = None) :
    """ Set the program's name. """

    global  OUR_NAME


    ov  = OUR_NAME

    if  name != None :
        OUR_NAME    = name

    return(ov)


our_title(OUR_TITLE)        # set the default name, too




def program_version_str(ident) :
    """
        Return a version number string, given an "ident",
        which looks like this, where 'whatever_the_program_name_is' and '0.00' are filled in with appropriate values:
        "<program_name>whatever_the_program_name_is</program_name><program_version>0.00</program_version>".

        In other words, we return "V0.00", given the above "ident" string.
    """

    return("V" + re.sub(r".*<program_version>([\d\.]+)</program_version>.*", r"\1", ident))



def frame_title(ident) :
    """ Return a string suitable for display in the program's title bar. """

    return(OUR_TITLE + " " + program_version_str(ident))




################################################################




def get_matching_wx_key(kc)    :
    """ Find a keycode among WX's keys to match the given one. Return either None or lower case string with the key name. """
    for kn in dir(wx)   :
        if  kn.startswith('WXK_') and (kc == getattr(wx, kn, None)) :

            return(kn[4:].lower())

        pass

    return(None)



################################################################


def paint_dot_on_full_screen(x, y, color = None, radius = None) :
    """ Paint a dot on the full screen. """
    if  wx      :
        dc      = wx.ScreenDC()
        w, h    = dc.Size
        dc.StartDrawingOnTop(None)
        if  color != None :
            dc.SetBrush(wx.TheBrushList.FindOrCreateBrush(color))
        dc.DrawCircle(x, y, int(radius or 5))
        dc.EndDrawingOnTop()
        dc.Destroy()
    pass




################################################################



def fit_win_dim(v, v_sz, screen_v, screen_sz) :
    """ Move the window around so it fits. And return a non-None size if the size must be forced to fill the window, mostly. """
    sz              = None
    if  v + v_sz    > screen_sz :           # east or south size off screen?
        v           = screen_sz - v_sz      # flush right or bottom
        if  v < 0   :                       # too big for screen?
            v       = 0                     # lock to west or top
            sz      = screen_sz - 5         # and make us almost screen sized
        pass
    return(v, sz)

def stable_window_dimensions(x, y, w, h) :
    """ Given .ini file window location/size, fix them if broken, and return them. """
    if  x is None : x       = 0
    if  y is None : y       = 0
    if  w is None : w       = 0
    if  h is None : h       = 0

    ( screen_w, screen_h )  = wx.GetDisplaySize()

    # print("@@@@@", name, screen_w, screen_h, x, y, w, h)
    if  (screen_w > 100) and (screen_h > 100) :
        wxy = wx.DefaultPosition
        if  (x != 0) or (y != 0) :
            wxy = wx.Point(int(x), int(y))
        wxy.x   = max(0, wxy.x)
        wxy.y   = max(0, wxy.y)

        x   = max(  0, x)
        y   = max(  0, y)
        w   = max(200, w)                       # use a minimum window size - this is usually a main window, after all
        h   = max(200, h)

        x, sz   = fit_win_dim(x, w, wxy.x, screen_w)
        if  sz is not None :     w  = sz
        y, sz   = fit_win_dim(y, h, wxy.y, screen_h)
        if  sz is not None :     h  = sz

    # print("@@@@@", name, wxy, screen_w, screen_h, x, y, w, h)
    return(int(x), int(y), int(w), int(h))







################################################################



def find_optimum_text_area_font_size(dc, w, h, font, txt, pad = '', line_break_chars = None, low_size = None, high_size = None) :
    """
        Given a Window and a width and hite, find the font size that will fit the given text fully in the window.

        If 'line_break_chars' is None, don't line break the text.
        If 'line_break_chars' is '', split the text on white space to get words assemble text lines with.
        Otherwise, txt.split(line_break_chars) to make "words" to assemble text lines with.

        'txt' is stripped of the 'line_break_chars' according to the above logic (not, white-space, 'line_break_chars').

        Each line will have the given 'pad' string put on both sides of it for width fitting.

        Note: Call font.SetPointSize(ps); dc.SetFont(font) before actually painting. Do not change the point size on the dc's font and expect it to paint matching this routine's results.

        Return the point size and an array of strings, each of which (they are stripped) go on a line - if 'line_break_chars' is not None.
    """
    pad             = pad or ''

    if  line_break_chars is None :
        words       = [ txt ]
    else            :
        if  line_break_chars :
            words   = txt.strip(line_break_chars).split(line_break_chars)
        else        :
            words   = txt.strip().split()               # line_break_chars is empty string, so just split the text on white space
        pass

    low_size        = ((low_size  is None) and 12) or low_size
    high_size       = ((high_size is None) and 97) or high_size

    def _fnd_txt_lines(w) :
        mxw         = 0
        ta          = []
        wa          = list(words)
        while len(wa) :
            ln      = ''
            while len(wa) :
                oln = ln
                wrd = wa[0]
                if  len(ln) :
                    ln += ' '
                ln += wrd
                lw  = dc.GetFullTextExtent(pad + ln + pad, font)[0]
                if  lw <= w  :
                    del(wa[0])
                    mxw = max(mxw, lw)
                elif not oln :
                    del(wa[0])                      # word does not fit, so overfly the width
                    mxw = max(mxw, lw)
                    break
                else :
                    ln  = oln
                    break
                pass
            if  ln  :
                ta.append(ln)
            pass

        return(ta, mxw)


    def _cmp_ps(a, i, item, cmp_obj) :
        font.SetPointSize(a[i])
        h       = sum(dc.GetFullTextExtent("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ", font)[1:])       # note: summing these numbers may not be strictly correct, but one or another of the OS's seems to like the extra vertical below the baseline

        ta, w   = _fnd_txt_lines(item[0])
        h      *= len(ta)
        # print("@@@@", i, a[i], w, h, item, ta)
        if  cmp(h, item[1]) > 0 :
            return(cmp(h, item[1]))
        return(    cmp(w, item[0]))

    a   = range(low_size, 72) + range(73, high_size)                # skip 72 for library bug reasons (bar: PIL bug, not wx?)
    pi  = tzlib.binary_search(a, (w,h), cmp_rtn = _cmp_ps)
    ps  = a[max(0, pi - 1)]

    font.SetPointSize(ps)
    ta  = _fnd_txt_lines(w)[0]

    return(ps, ta)



################################################################



#
#       From    http://www.py2exe.org/index.cgi/HowToDetermineIfRunningFromExe
#
import  imp

def main_is_frozen():
    return (hasattr(sys, "frozen") or           # new py2exe
           hasattr( sys, "importers")           # old py2exe
           or imp.is_frozen("__main__"))        # tools/freeze

def get_main_dir():
    if main_is_frozen():
        return(os.path.dirname(sys.executable))
    return(os.path.dirname(sys.argv[0]))




################################################################



def bail_out(s, exit = None) :
    """ Quit the program in a bit of an unfriendly way. """

    wx.MessageBox(s + "      ",   " " + OUR_TITLE + " ", wx.ID_OK | wx.ICON_ERROR)


    if  not exit is None :
        sys.exit(exit)

    raise   "User abort"



def show_msg(msg, options = 0, title = None, parent = None) :
    """
        Pop a OK/Cancel or whatever kind of dialog box to the user.
    """

    title   = title or OUR_NAME

    options = options or wx.OK
    dlg     = wx.MessageDialog(parent, msg, title, options)
    retval  = dlg.ShowModal()
    dlg.Destroy()                                                   # this must be done or the program won't exit! (Several days of work to find this.)

    return(retval)




################################################################



def rewrap_win_label(win, width) :
    """
        Wrap a window/control's label, keeping in mind that it may already be wrapped for some other width.

        Return True if the label changed, False if it did not.
    """

    s   = win.GetLabel()
    s  = re.sub(r"\s+", " ", s)
    win.SetLabel(s)

    win.Wrap(width)

    if  s == win.GetLabel() :
        return(False)
    return(True)




################################################################


class   a_help_dialog(wx.Dialog):
    """ Helper class. """

    def __init__(me, parent, msg, caption) :
        """ Create the dialog box. """

        wx.Dialog.__init__(me, parent, -1, caption)


        if  True :
            tb  = wx.BoxSizer(wx.HORIZONTAL)
            tv  = wx.BoxSizer(wx.VERTICAL)

            st  = wx.StaticText(me, -1)
            st.SetFont(wx.Font(8, wx.MODERN, wx.NORMAL, wx.NORMAL, False))
            st.SetLabel(msg)
            ( tx, ty )  = st.GetSize()
            st.Destroy()
            st  = wx.ScrollBar(me, -1, style = wx.SB_HORIZONTAL)
            ( x, sy )   = st.GetSize()
            st.Destroy()
            st  = wx.ScrollBar(me, -1, style = wx.SB_VERTICAL)
            ( sx, y )   = st.GetSize()
            st.Destroy()

            tw  = wx.TextCtrl(me, -1, style = wx.TE_READONLY | wx.TE_MULTILINE | wx.TE_DONTWRAP | wx.TE_NOHIDESEL)
            tw.SetFont(wx.Font(8, wx.MODERN, wx.NORMAL, wx.NORMAL, False))
            tw.SetBackgroundColour(me.GetBackgroundColour())            # ( 0xd0, 0xd0, 0xd0 ))
            tw.ChangeValue(msg)

            tv.Add(tw, 1, wx.EXPAND)
            tb.Add(tv, 1, wx.EXPAND)


        vb          = wx.BoxSizer(wx.VERTICAL)
        vb.AddSpacer(10)

        vb.Add(tb, 50, wx.EXPAND)

        vb.AddSpacer(20)

        bb          = wx.BoxSizer(wx.HORIZONTAL)
        bb.AddStretchSpacer(20)
        kb          = wx.Button(me, wx.ID_OK, "OK")
        ( x, by )   = kb.GetSize()
        bb.Add(kb)
        bb.AddStretchSpacer(20)

        vb.Add(bb, 2, wx.EXPAND)

        vspace      = 10
        if  sys.platform.find("linux") >= 0 :
            vspace  = 40
        vb.AddSpacer(vspace)


        dx          = dy    = 0
        ( dw, dh )  = wx.DisplaySize()
        dc          = wx.Display.GetCount()
        if  dc      :
            r       = wx.Display(0).GetGeometry()
            dx      = r.x
            dy      = r.y
            dw      = r.GetWidth()
            dh      = r.GetHeight()


        w   = min(tx + sx      + 20,          dw - 30)
        h   = min(ty + sy + by + 30 + vspace, dh - 30)
        me.SetSize((w, h))
        # me.CenterOnScreen(wx.BOTH)  # puts on zero-based display rather than 1st, primary display
        me.SetPosition((dx + max(0, (dw - w) // 2), dy + max(0, (dh - h) // 2)))

        me.SetSizer(vb)
        me.SetAutoLayout(True)
        me.Layout()



    pass    # a_help_dialog



def cmd_line_help(help_str) :
    """ Pop a dialog box with a mono-spaced message showing command line options. """

    dlg = a_help_dialog(None, help_str, OUR_NAME + " Command Line Options")
    dlg.ShowModal()
    dlg.Destroy()




################################################################


def set_label(win, label) :
    """ Set the label for the given window - but don't do it if there's no change as doing so will trigger an IDLE event. """
    if  win.GetLabel() != label :
        win.SetLabel(label)
    pass



################################################################


def window_showing(win) :
    """ Return True if the window is showing on screen. """
    return(win and win.IsShown())


################################################################


def window_size(win) :
    """ Return a rectangle (.x .y .width .height) with the given Window size, including title bar, etc. if it's a frame. """

    r               = win.GetRect()
    if  sys.platform.find("linux") >= 0 :
        cx, cy      = win.ClientToScreen(( 0, 0 ))
        bw          = cx - r.x
        tbh         = cy - r.y
        if  isinstance(win, wx.Frame) :
            # r.height += bw + bw + (tbh // 2)          # approximate
            r.height   += bw + wx.SYS_FRAMESIZE_Y
        else            :
            r.height   += bw + tbh                      # works on client panel?
        r.width    += bw + bw

    return(r)




################################################################


def is_event_within_windows(evt, wins) :
    """ Return whether the event is inside a box surrounding all the given windows. """

    x           = evt.GetX()
    y           = evt.GetY()

    lx          =   sys.maxsize
    hx          = -(sys.maxsize - 1)
    ly          =   sys.maxsize
    hy          = -(sys.maxsize - 1)
    for w in wins :
        if  hasattr(w, 'GetRect') :
            r   = w.GetRect()
        else    :
            p   = w.GetPosition()           # a BoxSizer, for instance
            sz  = w.GetSize()
            r   = [ p.x, p.y, sz.GetWidth(), sz.GetHeight(), ]
        lx      = min(lx, r[0])
        hx      = max(hx, r[0] + r[2])
        ly      = min(ly, r[1])
        hy      = max(hy, r[1] + r[3])

    return((lx <= x < hx) and (ly <= y < hy))




################################################################


def is_mouse_inside_window(win) :
    """ Is the mouse currently inside the given window? """
    mx, my  = wx.GetMousePosition()
    x,  y   = win.GetScreenPosition()
    w,  h   = win.GetSize()
    return((x <= mx < x + w) and (y <= my < y + h))


def is_mouse_inside_any_window(wins) :
    """ Is the mouse currently inside any of the the given windows? """
    mx, my  = wx.GetMousePosition()
    for win    in wins :
        x,  y   = win.GetScreenPosition()
        w,  h   = win.GetSize()
        if  ((x <= mx < x + w) and (y <= my < y + h)) :
            return(True)
        pass
    return(False)


def is_mouse_inside_all_windows(wins) :
    """ Is the mouse currently inside a box surrounding all the given windows. """
    mx, my      = wx.GetMousePosition()

    lx          =   sys.maxsize
    hx          = -(sys.maxsize - 1)
    ly          =   sys.maxsize
    hy          = -(sys.maxsize - 1)
    for win    in wins :
        x,  y   = win.GetScreenPosition()
        w,  h   = win.GetSize()
        lx      = min(lx, x)
        hx      = max(hx, x + w)
        ly      = min(ly, y)
        hy      = max(hy, y + h)

    return((lx <= mx < hx) and (ly <= my < hy))



################################################################


class   an_off_screen_html_window(object) :
    """
        Paint HTML to an off-screen bitmap.

        From                https://groups.google.com/forum/#!topic/wxpython-users/M2FVmlzh0cY

        From the code at    https://groups.google.com/group/wxpython-users/attach/8bd8c1f12f979c79/OffScreenHTML.py?part=0.1&authuser=0

    """

    def __init__(me, width, height, background_color = None, padding = None) :
        """ Initialize a new object. """
        me.width    = width
        me.height   = height
        me.buffer   = wx.EmptyBitmap(width, height)

        me.renderer = wx.html.HtmlDCRenderer()

        # a bunch of defaults...
        if  background_color is None :
            background_color    = 'white'
        me.background_color     = background_color
        me.padding              = padding or 0


    def render(me, source) :
        """ Render the html source to the bitmap. """
        dc  = wx.MemoryDC()
        dc.SelectObject(me.buffer)
        if  me.background_color.lower() == 'bgcolor' :
            g   = re.search(r'(?i)<body[^>]*?\sbgcolor\s*=\s*[\'"]([^\'"]+)[\'"]', source)
            if  g       :
                me.background_color = g.group(1)                # apparently, this renderer doesn't respect the body bgcolor, so we do the job for it
            else        :
                me.background_color = '#c0c0c0'                 # cute, old netscape, near-abouts
            pass

        dc.SetBackground(wx.Brush(me.background_color))
        dc.Clear()

        me.renderer.SetDC(dc, 1.0)
        me.renderer.SetSize(me.width - (2 * me.padding), me.height)

        me.renderer.SetHtmlText(source)
        me.renderer.Render(me.padding, me.padding, [])
        me.rendered_size    = (me.width, me.renderer.GetTotalHeight() + (2 * me.padding))

    def get_bitmap(me) :
        """ Get a bitmap that includes the rendered HTML, with the height fitted to the bottom of that which was rendered. """
        return(me.buffer.GetSubBitmap(wx.Rect(0, 0, *me.rendered_size)))

    def write_file(me, file_name) :
        """ Test/helper function to save the bitmap to an image file. """
        sub     = me.get_bitmap()
        typ     = None
        hs      = wx.Image.GetHandlers()
        ext     = os.path.splitext(file_name)[1][1:].lower()
        for h in hs :
            if  h.GetExtension() == ext :
                typ = h.GetType()
                break
            pass
        sub.SaveFile(file_name, typ or wx.BITMAP_TYPE_PNG)

    #   an_off_screen_html_window


################################################################


def window_client_to_bitmap(win):
    """ Return a bitmap that has what the given window's client area is showing right now. """
    w, h    = win.GetClientSize()
    bmp     = wx.EmptyBitmap(w, h)
    wdc     = wx.ClientDC(win)
    mdc     = wx.MemoryDC(bmp)
    mdc.Clear()
    mdc.Blit(0, 0, w, h, wdc, 0, 0)
    return(bmp)


def window_to_bitmap(win):
    """ Return a bitmap that has what the given window is showing right now. """
    w, h    = win.GetSize()
    bmp     = wx.EmptyBitmap(w, h)
    wdc     = wx.WindowDC(win)
    mdc     = wx.MemoryDC(bmp)
    mdc.Clear()
    mdc.Blit(0, 0, w, h, wdc, 0, 0)
    return(bmp)



################################################################


def write_window_image(me, app, fname = None) :
    """
        Write out a .png file of an image of 'me's (a Frame's) whole window.

        The 'app' may have a routine, screen_shot(me, fname, typ) that can play with the file after it's written (like annotates the image if it's a .png).


        This logic does a screen capture of the window area on-sceen.

        So if another window is over the window, it will get in the .png file.

        That's bad. !!!!


        And, it gets the file menu drop-down. So the caller should call this routine after a bit of a timeout.

        Notes:
            - tzlib.run_program('import -w "...TITLE..." file_name.png')          # doesn't get title bar, etc.
            - tzlib.run_program('gnome-screenshot -w')                            # like ours, gets the menu - maybe it wouldn't if a delay were given
            - or, works:
                - me.grab_screen  = True
                - on_idle:                                                        # this on-idle logic lets the menu item go away
                    - if  hasattr(me, 'grab_screen') :
                        - del(me.grab_screen)
                        - tzlib.run_program('scrot -b -u IMAGE_FILE_NAME')

                        - scrot uses XGetAttributes ... attr.width ... among other things

    """

    if  False :
        hx          = 0
        hd          = 0
        xw          = 0
        wd          = 0
        if  sys.platform.find("linux") >= 0 :
            hd      = wx.SYS_FRAMESIZE_Y + wx.SYS_FRAMESIZE_Y + 1   # + wx.SYS_MENU_Y
            hx      = wx.SYS_FRAMESIZE_Y + 4                        # + wx.SYS_MENU_Y
            wd      = 4                                             # wx.SYS_FRAMESIZE_X
            xw      = 8                                             # wx.SYS_FRAMESIZE_X + wx.SYS_FRAMESIZE_X
            # print("@@@@@", wx.SYS_FRAMESIZE_X, wx.SYS_FRAMESIZE_Y, wx.SYS_MENU_Y,  wx.SYS_CAPTION_Y,  wx.SYS_EDGE_X, wx.SYS_EDGE_Y,  wx.SYS_BORDER_X, wx.SYS_BORDER_Y)
        wdc         = wx.WindowDC(me)
        ( w, h )    = wdc.GetSizeTuple()

        w          += xw
        h          += hx
        bm          = wx.EmptyBitmap(w, h)
        dc          = wx.MemoryDC(bm)
        dc.Clear()

        dc.Blit(0, 0, w, h, wdc, -wd, -hd, wx.COPY)

    else            :
        r           = window_size(me)
        wdc         = wx.ScreenDC()
        bm          = wx.EmptyBitmap(r.width, r.height)
        dc          = wx.MemoryDC()
        dc.SelectObject(bm)
        dc.Blit(0, 0, r.width, r.height, wdc, r.x, r.y)
        dc.SelectObject(wx.NullBitmap)

    #
    #   In case we want to write a .jpg
    #
    try :
        im  = bm.ConvertToImage()           # this is what might cause an exception, like when I'm fooling with the monitors
        im.SetOption("quality", "50")
    except  :
        im  = None

    del(dc)
    del(bm)
    del(wdc)

    if  not im          :
        show_msg("Sorry. I cannot make a screen shot of my window!")
        fname           = None
    else                :
        if  not fname   :
            fname       =   None

            wildcard    =   "PNG (*.png)|*.png|"    \
                            "JPG (*.jpg)|*.jpg|"    \
                            "GIF (*.gif)|*.gif|"    \
                            "TIF (*.tif)|*.tif|"    \
                            "PNM (*.pnm)|*.pnm|"    \
                            "PCX (*.pcx)|*.pcx|"    \
                            "TGA (*.tga)|*.tga|"    \
                            "XPM (*.xpm)|*.xpm|"    \
                            "BMP (*.bmp)|*.bmp|"    \
                            "All files (*.*)|*.*"

            dflt_dir    =   os.getcwd()

            dlg         =   wx.FileDialog(me, message     = "Please tell me the file to save the window shot to ...",
                                              defaultDir  = dflt_dir,
                                              defaultFile = "",
                                              wildcard    = wildcard,
                                              style       = wx.FD_SAVE | wx.FD_OVERWRITE_PROMPT | wx.FD_PREVIEW
                                         )

            if  dlg.ShowModal() == wx.ID_OK :
                fname   = dlg.GetPath()

            dlg.Destroy()

        me.Refresh()

        if  fname   :
            ext     = os.path.splitext(fname)[1].lower().lstrip(".")
            if  ext == "jpeg" : ext = "jpg"

            typ     = None
            hs      = im.GetHandlers()
            for h in hs :
                if  h.GetExtension() == ext :
                    typ = h.GetType()
                    break
                pass
            if  not typ :
                show_msg("Sorry, I don't know how to write such a (%s) file!" % ( ext ) )
                fname   = None
            else :
                im.SaveFile(fname, typ)
                if  app and hasattr(app, 'screen_shot') :
                    app.screen_shot(fname, typ)         # let the app know about the file that's written
                pass
            pass
        pass

    return(fname)




################################################################



def set_icon(me, icon_data) :
    """ Set our icon at run time - not sure it's needed if py2exe is given an icon, but under interpretor it can affect some of the icon displays. """

    def getData(icon_data):
        return(zlib.decompress(icon_data))


    def getImage(icon_data):
        stream = StringIO(getData(icon_data))
        return(wx.ImageFromStream(stream))

    def getBitmap(icon_data):
        return(wx.BitmapFromImage(getImage(icon_data)))

    def getIcon(icon_data):
        icon    = wx.EmptyIcon()
        bm      = getBitmap(icon_data)
        icon.CopyFromBitmap(bm)
        return(icon)


    wx.InitAllImageHandlers()

    icon = getIcon(icon_data)
    me.SetIcon(icon)



def set_icon_uncompressed_data(me, icon_data) :
    """ Set our icon at run time - not sure it's needed if py2exe is given an icon, but under interpretor it can affect some of the icon displays. """

    def getImage(icon_data):
        stream = StringIO(icon_data)
        return(wx.ImageFromStream(stream))

    def getBitmap(icon_data):
        return(wx.BitmapFromImage(getImage(icon_data)))

    def getIcon(icon_data):
        icon    = wx.EmptyIcon()
        bm      = getBitmap(icon_data)
        icon.CopyFromBitmap(bm)
        return(icon)


    wx.InitAllImageHandlers()

    icon = getIcon(icon_data)
    me.SetIcon(icon)




################################################################



mchk    = None          # note: This must be persistent through the life of the program.

def program_already_running(system_wide = False) :
    """ Return True if our program is already running. Note that under Linux, at least, the system_wide flag does not work because SingleInstanceChecker includes the user name. """

    global  mchk

    lock_file_dir           = ""
    if  system_wide         :
        lock_file_dir       = system_wide
        if  not tzlib.is_stringish(system_wide) :
            lock_file_dir   = tempfile.gettempdir()
        pass
    if  not mchk :
        wx.Log.SetLogLevel(0)                                           # to avoid the stale lock popup
        mchk    = wx.SingleInstanceChecker(OUR_TITLE + "-" + str(wx.GetUserId()), path = lock_file_dir)
        if  mchk.IsAnotherRunning() :
            show_msg("Already running!", options = wx.OK | wx.STAY_ON_TOP)

            return(True)

        pass

    return(False)




################################################################



class   a_phone_homer(object) :
    """ Class to check for program updates and tell the user if there is one. """

    def __init__(me, app, realm = "", user_name = "", password = "") :
        me.app          = app

        me.phone_homer  = None

        me.realm        = realm
        me.user_name    = user_name
        me.password     = password

        me.have_it      = False

        if  me.app.no_phone_home or me.app.show_info or me.app.phone_home_url or me.app.ident :             # cause an error if what we use from the owner app does not exist
            pass            # ok

        pass



    def realm_user_password(me, realm, user_name, password) :
        """
            Set a realm, user name, and password for the phone-homer.
        """

        me.realm        = realm
        me.user_name    = user_name
        me.password     = password



    def stop(me) :
        """ Stop the process. Return some not-None if we're busy. """

        ph              = me.phone_homer
        me.phone_homer  = None

        if  ph :
            ph.stop()

        return(ph)



    def start(me) :
        """ Do it. """

        if  not me.app.no_phone_home :
            me.stop()

            me.phone_homer  = phone_homer.a_phone_homer(me, me.app.phone_home_url, program_version_str(me.app.ident), dir_to_stash_new_version_files = getattr(me.app, 'phone_homer_to_dir', None), add_version_to_file_name = True, show_info = me.app.show_info)

            if  me.realm :
                me.phone_homer.realm_user_password(me.realm, me.user_name, me.password)

            me.phone_homer.start()
        pass



    def phone_homer_done(me, version, files, download_count) :
        """ Callback from the phone homer to tell us what's up. """

        me.phone_homer  = None
        if  version and (len(files) > 0) :      # to tell 'em just when we download:      and (download_count > 0) :
            show_msg("There is a new version (%s) of the program downloaded to %s" % ( version, os.path.abspath(files[0]) ) )
            me.have_it  = True
        pass



    def have_new_version(me) :
        """ Return True if we have a new version ready to go. """

        return(me.have_it)



    pass    # a_phone_homer




################################################################



class   a_net_timer(object) :
    """ Class to get the network GMT time and update the PC clock if the user desires. """

    def __init__(me, app, warn_if_no_time = True) :
        me.app              = app
        me.warn_if_no_time  = warn_if_no_time

        me.net_timer        = None

        me.gmt              = 0
        me.tick             = 0

        if  me.app.no_net_time :                                        # cause an error if what we use from the owner app does not exist
            pass            # ok

        pass



    def stop(me) :
        """ Stop the process. Return some not-None if we're busy. """

        nt              = me.net_timer
        me.net_timer    = None

        if  nt :
            nt.stop()

        return(nt)



    def start(me) :
        tzlib.elapsed_time()

        if  not me.app.no_net_time :
            me.stop()

            me.net_timer    = tz_net_time.a_net_timer(me)
            me.net_timer.start()
        pass



    def time(me) :
        """ If we have the true time, return it. Otherwise return 0. """

        if  me.gmt :
            if  0 < tzlib.elapsed_time() - me.tick <= 60 * 15 :
                return(me.gmt + (tzlib.elapsed_time() - me.tick))       # let the time be good for only 15 minutes (winxp hibernation resets elapsed_time counter back to zero, btw)
            pass

        return(0)



    def net_timer_done(me, gmt) :
        """ Callback from the net time logic to tell us what it got. """

        me.net_timer    = None
        me.gmt          = gmt
        me.tick         = tzlib.elapsed_time()
        pct             = time.time()

        if  gmt <= 0 :
            if  me.warn_if_no_time :
                show_msg("I could not find the GMT time out on the internet!\r\n"
                         "This means that I will do things relative to your PC's clock.\r\n\r\n"
                         "PC clocks are not notably accurate.\r\n"
                        )
            pass
        elif abs(pct - gmt) >= 2.5 :
            set_pc  = show_msg("Your PC's clock seems to be %s.\r\n"
                               "Should I attempt to fix it?\r\n" % ( tz_parse_time.time_diff_str(gmt, pct) ),
                               options  = wx.YES_NO | wx.NO_DEFAULT
                              )
            if  (set_pc == wx.ID_YES) and me.time() :                   # give 'em 15 minutes to respond
                if  not tz_net_time.set_system_time(me.time()) :
                    show_msg("I could not fix the system time. Sorry.")
                pass
            pass
        else :
            # print("time found", gmt, pct)
            pass
        pass



    pass    # a_net_timer




################################################################


class   a_text_entry_popup(wx.Dialog) :
    """ Define a text entry modal dialog box. """

    def __init__(me, parent, id, title = None, prompt = None, ok_label = None, soft_keyboard = None, *args, **kwargs) :
        """ Make an object. """

        sty             =  wx.RESIZE_BORDER | wx.CLOSE_BOX | wx.SYSTEM_MENU | wx.THICK_FRAME | wx.STAY_ON_TOP | wx.CAPTION
        if  len(args)   > 2 :
            args[1]    |= sty
        else            :
            kwargs['style'] = kwargs.get('style', 0) | sty
        wx.Dialog.__init__(me, parent, id or wx.ID_ANY, title = title or "Tell Me", *args, **kwargs)

        vbox            = wx.BoxSizer(wx.VERTICAL)

        me.prompt       = None
        if  prompt      :
            me.prompt   = wx.StaticText(me, -1, prompt)

        me.txt          = wx.TextCtrl(me, wx.ID_ANY, style = wx.TE_NOHIDESEL | wx.TE_MULTILINE | wx.TE_AUTO_URL | wx.TE_RICH2)

        hbox            = wx.BoxSizer(wx.HORIZONTAL)
        hbox.AddStretchSpacer(1)

        me.cancel       = wx.Button(me, wx.ID_CANCEL,   label = "Cancel")
        hbox.Add(me.cancel, 0, wx.EXPAND)

        me.ok           = wx.Button(me, wx.ID_OK,       label = ok_label or "OK")
        hbox.Add(me.ok,     0, wx.EXPAND)

        if  me.prompt   :
            vbox.AddSpacer(10)
            hhbox       = wx.BoxSizer(wx.HORIZONTAL)
            hhbox.AddStretchSpacer(1)
            hhbox.Add(me.prompt,   0, wx.ALL | wx.EXPAND)
            hhbox.AddStretchSpacer(1)
            vbox.Add(hhbox,        0, wx.ALL | wx.EXPAND)
            vbox.AddSpacer(10)

        vbox.Add(me.txt,           1, wx.ALL | wx.EXPAND)

        me.soft_kbrd    = soft_keyboard
        if  me.soft_kbrd :
            vbox.AddSpacer(10)
            me.soft_kbrd.Reparent(me)
            me.soft_kbrd.SendSizeEvent()
            vbox.Add(me.soft_kbrd, 1, wx.EXPAND)

        vbox.AddSpacer(10)
        vbox.Add(hbox,             0, wx.ALL | wx.EXPAND)
        vbox.AddSpacer(10)

        me.txt.SetFocus()
        me.SetSize(( 600, 400 ))

        me.SetSizer(vbox)
        me.SetAutoLayout(True)

        if  me.soft_kbrd :
            me.laid = 1000                                  # seems to work
            me.Bind(wx.EVT_UPDATE_UI, me.on_show)
        pass


    def on_show(me, evt = None) :
        """ Lay us out so the soft keyboard can expand. """
        if  me.laid     :
            me.laid    -= 1
            me.Layout()
        pass


    def GetValue(me) :
        """ Return the text entered. """
        return(me.txt.GetValue())

    #   a_text_entry_popup





################################################################


class   a_progress_status_bar(wx.StatusBar) :
    """
        Define a status bar that can implement a progress bar.

        This status bar contains fields with text in them. The last field can have its background changed to reflect progress.
    """

    def __init__(me, frame, sizes) :
        """ Initialize/instantiate an object. """

        super(a_progress_status_bar, me).__init__(frame)

        me.color        = 'CYAN'

        me.changed      = True

        me.SetFieldsCount(len(sizes))
        me.SetStatusWidths(sizes)

        for i in range(me.GetFieldsCount()) :
            me.SetStatusText("", i)

        me.prog_i       = me.GetFieldsCount() - 1
        me.where        = 0.0
        me.how_many     = 0.0
        me.prog_txt     = ""

        me.Bind(wx.EVT_SIZE, me.on_size)
        me.Bind(wx.EVT_IDLE, me.on_idle)


    def on_size(me, evt = None) :
        """ Handle size events. Repaint the progress bar at idle time. """
        # me.update_me()
        me.changed      = True


    def on_idle(me, evt = None) :
        """ Handle idle events. If the progress bar has changed, re-paint it. """
        if  me.changed :
            me.update_me()
        pass


    def update_me(me) :
        """ Draw the latest progress bar. """
        if  me.how_many <= 0.0 :
            me.SetStatusText("", me.prog_i)
        else :
            pw  = me.where / me.how_many
            r   = me.GetFieldRect(me.prog_i)
            dc  = wx.ClientDC(me)
            me.SetStatusText(me.prog_txt, me.prog_i)
            dc.SetLogicalFunction(wx.AND)
            dc.SetBrush(wx.Brush(me.color))
            dc.SetPen(wx.Pen(me.color))
            dc.DrawRectangle(r.GetX(), r.GetY(), int(r.GetWidth() * pw), r.GetHeight())

        me.changed      = False


    def on_progress(me, where, how_many, txt = None) :
        """ Keep a progress bar up to date. """
        how_many = max(0.0, float(how_many))
        where    = min(max(0.0, float(where)), how_many)

        if  txt != None :
            if  me.prog_txt != txt :
                me.prog_txt =  txt
                me.changed  =  True
            pass

        if  me.how_many != how_many :
            me.how_many =  how_many
            me.changed  =  True

        if  me.where   !=  where :
            me.where    =  where
            me.changed  =  True

        if  me.changed :
            me.Refresh()
            me.Update()

        pass


    def set_msg(me, field, msg) :
        """ Set the message in a field. """
        me.SetStatusText(msg, field)
        me.changed  = True


    pass    # a_progress_status_bar





################################################################



class   an_app(wx.App) :
    """
        Define a class of a wx app to able to use HTML windows that have memory file system URLs for .png files.

        Note: This class is really to define a wx-able app for a command line program.

        It should be instantiated like this "app = an_app(False)" so that under Windows the program will print to the console rather than to a wx window that goes away on program exit.

    """
    def make_images_made_available_to_html(me, images_made) :
        """
            Put all the images_made images in a fake file system so HTML can refer to them with memory:name_of_png_file.

            images_made is a module containing routines that take no parameter and return a latin1 string containing a .png file.

            The file name is the routine name with .png appended as the extension.

            The HTML for the following PNG file would be: "<img src='memory:mark.png'>".

            For example:
                <pre>
                - def  mark() :
                -      return '\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR\x00\x00\x00\t\x00\x00\x00\t\x08\x06\x00\x00\x00\xe0\x91\x06\x10\x00\x00\x00\x01sRGB\x00\xae\xce\x1c\xe9\x00\x00\x00\x06bKGD\x00\xff\x00\xff\x00\xff\xa0\xbd\xa7\x93\x00\x00\x00\tpHYs\x00\x00.#\x00\x00.#\x01x\xa5?v\x00\x00\x00\x07tIME\x07\xde\x05\x19\n85M\xaa\xbd\x94\x00\x00\x00oIDAT\x18\xd3\x8d\xd0;\n\xc3@\x0c\x84\xe1O.6\xd7\xc9\xc3\x07\xd8#\xf8\x82!Wq\x17\x02&\xe4<n\x94f\x03\xcb\x16\xc1\xea\xe6\x97\x98\x19$k.\xfeL\xd6\\"k\x9e\xb0a\xc6\x1ekd\xd6\x0c\x94\x1f\x8f\x11`\x1f\xf5\x14kd[\xccx\xe2\x82W\xef\x1c]v\xe0\x8c7\xae\xf84\x03SwPp\xc7\r\x0f\x94\xc6\x1d\xeb4\x82\xa1\xe3\x86\xe2\xc8\x9f\xbe3\'9_\x9f@\x1d\x03\x00\x00\x00\x00IEND\xaeB`\x82'
                </pre>

            Return the memory file system created as me.memory_file_system.

        """
        me.memory_file_system   = wx.MemoryFSHandler()
        wx.FileSystem_AddHandler(me.memory_file_system)
        for irtn in dir(  images_made) :
            rtn = getattr(images_made, irtn)
            if  hasattr(rtn, '__call__') :
                try :
                    png = rtn()
                    if  tzlib.is_stringish(png) and png.startswith(b"\x89PNG\r\n\x1a\n\x00\x00\x00\rIHDR") :
                        me.memory_file_system.AddFile(irtn + ".png", png, wx.BITMAP_TYPE_PNG)
                    pass
                except TypeError :
                    pass
                pass
            pass
        return(me.memory_file_system)
    #   an_app





################################################################



#
#
#       Test
#
#
if __name__ == '__main__' :

    pass

#
#
#
# eof
